// To compile :
// # c++ -o calc calculate.cpp
// or
// # g++ -o calc calculate.cpp


#include <iostream>
#include <cstdlib>
#include <cctype>
#include <cstring>
#include <string>

void eatspaces (char* str);
double expr(char* str);
double term(char* str, int& index);
double number (char* str, int& index);
char* extract(char* str, int& index);
void help();
void info();
const int max = 80;

//start with the parameters... :) (it finally works)
int main(int argc, char * argv[])
{
	char buffer[max] = {0};
		if (argc > 1)
		{
			for (int i=1;i<argc;++i)
			{
				if (!strcmp(argv[i], "-h"))
				//print the help
				{
					help();
					exit(1);
				}
			
				if (!strcmp(argv[i], "-v"))
				//verbose mode...
				{
					info();
					help();
					exit(1);
				}
				if (!strcmp(argv[i], "-s"))
				//give along the string
				{
					for (int x=i+1;x<argc;++x)
					{
						strcat (buffer, argv[x]);
					}
					eatspaces(buffer);
					std::cout <<  expr(buffer) << std::endl;
				}
			}
		}
		else 
		//use forgot parameters
		{			
			info();
			help();
			exit(1);
		}
			
}

//this funtion 'eats' the spaces in a string
void eatspaces(char* str)
{
	int i = 0;
	int j = 0;

	while ((*(str + i) = *(str + j++)) != '\0')
		
		if (*(str + i) != ' ')
			i++;
		return;
}

//this function evaluates the string (partially)
double expr(char* str)
{
	double value = 0.0;
	int index = 0;

	value = term(str, index);

	for (;;)
	{
		switch(*(str + index++))
		{
		case '\0' :
			return value;
		case '+' :
			value += term(str,index);
			break;
		case '-' :
			value -= term(str, index);
			break;
		default:
			exit(1);
		}
	}
}

// other part of the evaluation
double term(char* str, int& index)
{
	double value = 0.0;
	
	value = number(str, index);
	while ((*(str +index) == '*' || (*(str + index) == '/')))
	{
		if (*(str + index) == '*')
			value *= number(str, ++index);
		if (*(str + index) == '/')
			value /= number(str, ++index);
	}
	return value;
}




double number(char* str, int& index)
{
	double value = 0.0 ;
	
	if (*(str + index) == '(')
	{
		char* psubstr = 0;
		psubstr = extract(str, ++index);
		value = expr(psubstr);
		delete[]psubstr;
		return value;
	}
	while(isdigit(*(str + index)))
		value = 10*value + (*(str + index++) -48);

	if (*(str + index) !='.')
		return value;
	
	double factor = 1;
	while (isdigit(*(str + (++index))))
	{
		factor *= 0.1;
		value = value + (*(str + index) -48)*factor;
	}
	return value;
}
//this function extracts a part of the string an replaces it 
char* extract(char* str, int& index)
{
	char buffer[max];
	char* pstr = 0;
	int numL = 0;
	int bufindex = index;

	do
	{
		buffer[index - bufindex] = *(str + index);
		switch (buffer[index-bufindex])
		{
		case ')':
				if(numL == 0)
				{
					buffer[index - bufindex] = '\0';
					++index;
						pstr = new char[index - bufindex];
					if (!pstr)
					{
						exit(1);
					}
					strcpy(pstr, buffer);
					return pstr;
				}
				else
					numL--;
				break;

		case '(':
			numL++;
			break;
		}
	}while (*(str + index++) != '\0');
		exit(1);
	return pstr;
}

void info()
//print the  version info
{
	std::cout << "Calc v1.0 Stable\t Programmed by Ti_Uhl, modified by Dvalin" << std::endl;
}

void help()
//print the instructions
{
	std::cout << "Use : calc [flag] [parameter]\n"
		 << "Flags :\n"
		 << "\t-h\t: Print this help\n"
		 << "\t-s\t: String to process\n"
		 << "\t-v\t: Verbose use\n";
}
	
